guiSetGetMenue = {};

local error0 = "!! ERROR !! Gui Menue ";
local error1 = "Install GuiMenue before Game Load (you can also create a blank mod menue and fill it in later)";
local error2 = "Your args table not found ( {modGuiMenueVersion=...., modMenueName=.... etc.} )";
local error3 = "modGuiMenueVersion/modMenueName not Found or incorrect\n--> g_currentMission.guiMenue.guiSetGetMenue:generateModMenue( {modGuiMenueVersion=..., modMenueName=..., onOpenCallback(optional)=...., onCloseCallback(optional)=..., onSaveCallback(optional)=..., modVersion(optional)=..., modAuthor(optional)=...} )";
local error4 = "Your args table not found\n--> g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePage( {modMenueTable=...., pageType=..., masterPageName=...(optional), masterPageGlobalName=...(optional), slavePageName...(optional is pageType slave), slavePageGlobalName...(optional is pageType slave), onOpenCallback=...(optional), onCloseCallback=...(optional)} )";
local error5 = "Found Already Exists PageSide and Line (double line not possible, replace a line, set replaceLine=true)";
local error6 = "Not found or incorrect value string pageType=... (set 'master' or 'slave' in pageType)";
local error7 = "Not found masterPage=... number or incorrect\n--> g_currentMission.guiMenue.guiSetGetMenue:generateModMenueSlavePage( {modMenueTable=..., masterPage=..., slavePageName=...(optional), slavePageGlobalName=...(optional) } )";
local error8 = "Found masterPage Side. Double function not possible. Set correct masterPage number and is generateModMenuePage.... correct !";
local error9 = "Your args table not found\n--> g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=...., pageType=..., pageSideName=...(optional), pageSideGlobalName=...(optional), onOpenCallback=...(optional), onCloseCallback=...(optional)} )";
local error10 = "Your args table not found\n--> g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=..., lineButtonTable=..., line=...(optional,default last), replaceLine...(optional), masterPage=...(optional,default last), slavePage(optional, needs masterPage,default last)=..., pageSide=...(optional, default last), maxButton=...(optional, default 0 and line then hidden), isHidden=...(optional) })";
local error11 = "Not found a page/line/maxButton or incorrect number value masterPage or slavePage or pageSide or maxButton or line=... (set number and is slavePage and/or pageSide then needs masterPage)";
local error12 = "Not found lineButtonTable= or incorrect";
local error13 = "Not found or incorrect number value masterPage or slavePag or pageSide=... (set number and is slavePage then needs masterPage, set number is pageSide then needs slavePage)";
local error14 = "Your args tablr not Found or incorrect\n--> g_currentMission.guiMenue.guiSetGetMenue:insertModMenuePageSide( {modGuiMenueVersion=..., masterPage=..., slavePage=..., pageSide=...(optional,default last, pageSideName=...(optional), pageSideGlobalName=...(optional), onOpenCallback=...(optional), onCloseCallback=...(optional)} )";


function guiSetGetMenue:generateModMenue(...) --for mod, value updateGuiMenue only for Gui Menue (a mod set not or Problem)
	if g_currentMission.guiMenue.mapIsLoad then return false, nil, nil, "", error0.. "*in generateModMenue* ".. error1;end;
	if ... == nil or type(...) ~= "table" then return false, nil, nil, "", error0.. "*in generateModMenue* ".. error2;end;	
	local args = ...;
	if args.onOpenCallback ~= nil and type(args.onOpenCallback) ~= "function" then args.onOpenCallback = nil;end;
	if args.onCloseCallback ~= nil and type(args.onCloseCallback) ~= "function" then args.onCloseCallback = nil;end;
	if args.onSaveCallback ~= nil and type(args.onSaveCallback) ~= "function" then args.onSaveCallback = nil;end;
	local isGenerate, isUpToDate, installModGuiTablePos, errorTxt, infoTxt = true, false, 0, "", "Gui Menue is UpToDate";
	if args.modMenueName == nil or type(args.modMenueName) ~= "string" or args.modGuiMenueVersion == nil or type(args.modGuiMenueVersion) ~= "number" then 
		errorTxt =  error0.. "*in generateModMenue* ".. error3;
		isGenerate = false;
	else
		local foundNewGuiMenueScript = false;		
		if tonumber(args.modGuiMenueVersion) < tonumber(g_currentMission.guiMenue.master.metadata.guiMenueVersion) then			
			if #g_currentMission.guiMenue.script.disableVersion > 0 then
				for a=1, #g_currentMission.guiMenue.script.disableVersion do
					if tonumber(g_currentMission.guiMenue.script.disableVersion[a]) == tonumber(args.modGuiMenueVersion) then
							foundNewGuiMenueScript = true;
						break;
					end;
				end;
			end;
		else
			isUpToDate = true;
		end;
		if not isUpToDate and not foundNewGuiMenueScript then infoTxt = "!! INFO !! Gui Menue for ".. tostring(args.modMenueName).. " not more UpToDate (works anyway) (info to modders) !!";end;
		if foundNewGuiMenueScript then 
			isGenerate = false;
			errorTxt = "!! WARNING !!  Disable Gui Menue in ".. tostring(args.modMenueName).. " (not more UpToDate) (info to modders) !!";			
		end;		
		if args.updateGuiMenue ~= nil and args.updateGuiMenue then 
			g_currentMission.guiMenue.modTable[1] = {};
		else
			g_currentMission.guiMenue.modTable[#g_currentMission.guiMenue.modTable+1] = {};
		end;
		local mod = #g_currentMission.guiMenue.modTable;
		if args.updateGuiMenue ~= nil and args.updateGuiMenue then mod = 1;end;
		installModGuiTablePos = mod;
		g_currentMission.guiMenue.modTable[mod].lastMouseCursorState = false;
		g_currentMission.guiMenue.modTable[mod].name = Utils.getNoNil(tostring(args.modMenueName), "Unknown Mod ".. tostring(mod));
		g_currentMission.guiMenue.modTable[mod].guiMenueVersion = Utils.getNoNil(tonumber(args.modGuiMenueVersion), 0.1);
		g_currentMission.guiMenue.modTable[mod].isUpToDate = isUpToDate;
		g_currentMission.guiMenue.modTable[mod].isGenerate = isGenerate;
		g_currentMission.guiMenue.modTable[mod].errorTxt = "";
		g_currentMission.guiMenue.modTable[mod].version = Utils.getNoNil(tostring(args.modVersion), "");
		g_currentMission.guiMenue.modTable[mod].author = Utils.getNoNil(tostring(args.modAuthor), "");
		g_currentMission.guiMenue.modTable[mod].save = false;
		g_currentMission.guiMenue.modTable[mod].isHidden = false; --für Deinstallation von MultiOverlayV3 Apps 
		g_currentMission.guiMenue.modTable[mod].onOpenCallback = args.onOpenCallback or nil; --optional function for return open mod
		g_currentMission.guiMenue.modTable[mod].onCloseCallback = args.onCloseCallback or nil; --optional function for return close mod
		g_currentMission.guiMenue.modTable[mod].onSaveCallback = args.onSaveCallback or nil; --optional function for return save button click in GuiMenue
		g_currentMission.guiMenue.modTable[mod].tempSave = false;
		g_currentMission.guiMenue.modTable[mod].getButtonInfo = {};		
		g_currentMission.guiMenue.modTable[mod].lastOpenPage = {masterPage=1, slavePage=1, pageSide=1};
		g_currentMission.guiMenue.modTable[mod].page = {};		
		g_currentMission.guiMenue.modTable[mod].returnClick = {name="", line=0, button=0, pullDownLine=0};				
	end;	
	return isGenerate, isUpToDate, installModGuiTablePos, errorTxt, infoTxt;
end;

function guiSetGetMenue:generateModMenuePage(...) --for master page and slave page	
	if ... == nil or type(...) ~= "table" then return false, error0.. "*in generateModMenuePage* ".. error4;end;
	local args = ...;
	if args.onOpenCallback ~= nil and type(args.onOpenCallback) ~= "function" then args.onOpenCallback = nil;end;
	if args.onCloseCallback ~= nil and type(args.onCloseCallback) ~= "function" then args.onCloseCallback = nil;end;
	local isGenerate, errorTxt = false, "";	
	if args.modMenueTable == nil or (args.modMenueTable ~= nil and type(args.modMenueTable) ~= "number") or g_currentMission.guiMenue.modTable[args.modMenueTable] == nil or not g_currentMission.guiMenue.modTable[args.modMenueTable].isGenerate then 
		errorTxt = error0.. "*in generateModMenuePage* ".. error3;		
		if not g_currentMission.guiMenue.modTable[args.modMenueTable].isGenerate then errorTxt = "";end; --stop double txt
	elseif args.pageType == nil or type(args.pageType) ~= "string" then		
		errorTxt = error0.. "*in generateModMenuePage* ".. error6;	
	else
		local mod = args.modMenueTable;		
		g_currentMission.guiMenue.modTable[args.modMenueTable].page[#g_currentMission.guiMenue.modTable[args.modMenueTable].page+1] = {};
		local masterPage = #g_currentMission.guiMenue.modTable[args.modMenueTable].page;		
		g_currentMission.guiMenue.modTable[mod].page[masterPage].name = args.masterPageName or "Master Page";
		g_currentMission.guiMenue.modTable[mod].page[masterPage].globalName = args.masterPageGlobalName or "masterPage".. tostring(masterPage).. "_";			
		g_currentMission.guiMenue.modTable[mod].page[masterPage].onOpenCallback = args.onOpenCallback; --optional function for return open page
		g_currentMission.guiMenue.modTable[mod].page[masterPage].onCloseCallback = args.onCloseCallback; --optional function for return close page			
		g_currentMission.guiMenue.modTable[mod].page[masterPage].pageType = "modMasterPageSide";
		g_currentMission.guiMenue.modTable[mod].page[masterPage].side = {};			
		if string.lower(args.pageType) == "slave" then			
			g_currentMission.guiMenue.modTable[mod].page[masterPage].page = {};
			g_currentMission.guiMenue.modTable[mod].page[masterPage].page[#g_currentMission.guiMenue.modTable[mod].page[masterPage].page+1] = {};
			local slavePage = #g_currentMission.guiMenue.modTable[mod].page[masterPage].page;
			g_currentMission.guiMenue.modTable[mod].page[masterPage].page[slavePage].name = args.slavePageName or args.masterPageName or "Slave Page";
			g_currentMission.guiMenue.modTable[mod].page[masterPage].page[slavePage].globalName = args.slavePageGlobalName or args.masterPageGlobalName or "slavePage".. tostring(slavePage);
			g_currentMission.guiMenue.modTable[mod].page[masterPage].page[slavePage].side = {};
			g_currentMission.guiMenue.modTable[mod].page[masterPage].pageType = "modSlavePageSide";
		end;
		isGenerate = true;	
	end;	
	if not isGenerate and g_currentMission.guiMenue.modTable[args.modMenueTable] ~= nil then g_currentMission.guiMenue.modTable[args.modMenueTable].isGenerate = false;g_currentMission.guiMenue.modTable[args.modMenueTable].errorTxt="An error occurred while creating a page";end;
	return isGenerate, errorTxt;
end;

function guiSetGetMenue:generateModMenueSlavePage(...)
	if ... == nil or type(...) ~= "table" then return false, error0.. "*in generateModMenueSlavePage* ".. error4;end;
	local args = ...;
	local isGenerate, errorTxt = false, "";
	if args.modMenueTable == nil or (args.modMenueTable ~= nil and type(args.modMenueTable) ~= "number") or g_currentMission.guiMenue.modTable[args.modMenueTable] == nil or not g_currentMission.guiMenue.modTable[args.modMenueTable].isGenerate then 
		errorTxt = error0.. "*in generateModMenueSlavePage* ".. error3;		
		if not g_currentMission.guiMenue.modTable[args.modMenueTable].isGenerate then errorTxt = "";end; --stop double txt
	elseif args.masterPage == nil or (args.masterPage ~= nil and type(args.masterPage) ~= "number") or g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage] == nil then
		errorTxt = error0.. "*in generateModMenueSlavePage* ".. error7;
	elseif #g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage].side > 0 then
		errorTxt = error0.. "*in generateModMenueSlavePage* ".. error8;
	else
		local mod = args.modMenueTable;
		local masterPage = args.masterPage
		if g_currentMission.guiMenue.modTable[mod].page[masterPage].page == nil then g_currentMission.guiMenue.modTable[mod].page[masterPage].page = {};end;
		g_currentMission.guiMenue.modTable[mod].page[masterPage].page[#g_currentMission.guiMenue.modTable[mod].page[masterPage].page+1] = {};
		local slavePage = #g_currentMission.guiMenue.modTable[mod].page[masterPage].page;
		g_currentMission.guiMenue.modTable[mod].page[masterPage].page[slavePage].name = args.slavePageName or g_currentMission.guiMenue.modTable[mod].page[masterPage].name or "Slave Page";
		g_currentMission.guiMenue.modTable[mod].page[masterPage].page[slavePage].globalName = args.slavePageGlobalName or g_currentMission.guiMenue.modTable[mod].page[masterPage].globalName or "slavePage".. tostring(slavePage);
		g_currentMission.guiMenue.modTable[mod].page[masterPage].page[slavePage].side = {};
		g_currentMission.guiMenue.modTable[mod].page[masterPage].pageType = "modSlavePageSide";
		isGenerate = true;
	end;	
	return isGenerate, errorTxt;
end;

function guiSetGetMenue:generateModMenuePageSide(...) --for master page Side and slave page side	
	if ... == nil or type(...) ~= "table" then return false, error0.. "*in generateModMenuePageSide* ".. error9;end;
	local args = ...;
	if args.onOpenCallback ~= nil and type(args.onOpenCallback) ~= "function" then args.onOpenCallback = nil;end;
	if args.onCloseCallback ~= nil and type(args.onCloseCallback) ~= "function" then args.onCloseCallback = nil;end;
	local isGenerate, errorTxt = false, "";
	if args.modMenueTable == nil or (args.modMenueTable ~= nil and type(args.modMenueTable) ~= "number") or g_currentMission.guiMenue.modTable[args.modMenueTable] == nil then 
		errorTxt = error0.. "*in generateModMenuePageSide* ".. error3;				
	elseif args.pageType == nil or type(args.pageType) ~= "string" then		
		errorTxt = error0.. "*in generateModMenuePageSide* ".. error6;
	elseif (string.lower(args.pageType) == "master" and g_currentMission.guiMenue.modTable[args.modMenueTable].page[#g_currentMission.guiMenue.modTable[args.modMenueTable].page].pageType == "modSlavePageSide") or (string.lower(args.pageType) == "slave" and g_currentMission.guiMenue.modTable[args.modMenueTable].page[#g_currentMission.guiMenue.modTable[args.modMenueTable].page].pageType == "modMasterPageSide") then
		errorTxt = error0.. "*in generateModMenuePageSide* pageType not identical";
		--print("pageType=".. tostring(string.lower(args.pageType)).. " -isPageType=".. tostring(g_currentMission.guiMenue.modTable[args.modMenueTable].page[#g_currentMission.guiMenue.modTable[args.modMenueTable].page].pageType)        )
	elseif string.lower(args.pageType) == "master" then
		local mod = args.modMenueTable;	
		local modTable = g_currentMission.guiMenue.modTable[mod];
		local masterPage = #modTable.page;
		if modTable.page[masterPage].side == nil then modTable.page[masterPage].side = {};end;
		modTable.page[masterPage].side[#modTable.page[masterPage].side+1] = {};
		local pageSide = #modTable.page[masterPage].side;
		modTable.page[masterPage].side[pageSide].name = args.pageSideName or "Master Page Side ".. tostring(pageSide);
		modTable.page[masterPage].side[pageSide].globalName = args.pageSideGlobalName or "masterPageSide".. tostring(pageSide);
		modTable.page[masterPage].side[pageSide].onOpenCallback = args.onOpenCallback;
		modTable.page[masterPage].side[pageSide].onCloseCallback = args.onCloseCallback;
		modTable.page[masterPage].side[pageSide].line = {};
		modTable.page[masterPage].side[pageSide].viewLines = {maxLine=1, bounds={1, 1}};
		isGenerate = true;		
	elseif string.lower(args.pageType) == "slave" then	
		local mod = args.modMenueTable;
		local modTable = g_currentMission.guiMenue.modTable[mod];
		local masterPage = #modTable.page;
		local slavePage = #modTable.page[masterPage].page;
		if modTable.page[masterPage].page[slavePage].side == nil then modTable.page[masterPage].page[slavePage].side = {};end;
		modTable.page[masterPage].page[slavePage].side[#modTable.page[masterPage].page[slavePage].side+1] = {};
		local pageSide = #modTable.page[masterPage].page[slavePage].side;
		modTable.page[masterPage].page[slavePage].side[pageSide].name = args.pageSideName or "Slave Page Side";
		modTable.page[masterPage].page[slavePage].side[pageSide].globalName = args.pageSideGlobalName or "slavePageSide ".. tostring(pageSide);
		modTable.page[masterPage].page[slavePage].side[pageSide].onOpenCallback = args.onOpenCallback;
		modTable.page[masterPage].page[slavePage].side[pageSide].onCloseCallback = args.onCloseCallback;
		modTable.page[masterPage].page[slavePage].side[pageSide].line = {};
		modTable.page[masterPage].page[slavePage].side[pageSide].viewLines = {maxLine=1, bounds={1, 1}};
		isGenerate = true;		
	end;	
	return isGenerate, errorTxt;
end;

function guiSetGetMenue:insertModMenuePageSide(...) 
	if ... == nil or type(...) ~= "table" then return false, error0.. "*in insertModMenuePageSide* ".. error14;end;
	local args = ...;
	if args.onOpenCallback ~= nil and type(args.onOpenCallback) ~= "function" then args.onOpenCallback = nil;end;
	if args.onCloseCallback ~= nil and type(args.onCloseCallback) ~= "function" then args.onCloseCallback = nil;end;
	local isGenerate, errorTxt = false, "";
	if args.modMenueTable == nil or (args.modMenueTable ~= nil and type(args.modMenueTable) ~= "number") or g_currentMission.guiMenue.modTable[args.modMenueTable] == nil then 
		errorTxt = error0.. "*in insertModMenueSlavePageSide* ".. error3;				
	elseif args.pageType == nil or type(args.pageType) ~= "string" then		
		errorTxt = error0.. "*in insertModMenuePageSide* ".. error6;
	elseif (string.lower(args.pageType) == "master" and g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage].pageType == "modSlavePageSide") or (string.lower(args.pageType) == "slave" and g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage].pageType == "modMasterPageSide") then
		errorTxt = error0.. "*in insertModMenuePageSide* pageType not identical";
	elseif (args.masterPage ~= nil and type(args.masterPage) ~= "number") or (args.slavePage ~= nil and type(args.slavePage) ~= "number") or
			(args.slavePage ~= nil and args.masterPage == nil) or (args.pageSide ~= nil and args.masterPage == nil) or (args.pageSide ~= nil and args.slavePage ~= nil and args.masterPage == nil) or
			(args.masterPage ~= nil and g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage] == nil) or 
			(args.masterPage ~= nil and args.pageSide ~= nil and modTable.page[args.masterPage].side[args.pageSide] == nil) or
			(args.masterPage ~= nil and args.slavePage ~= nil and args.pageSide ~= nil and modTable.page[args.masterPage].page[args.slavePage].side[pageSide] == nil) then
			errorTxt = error0.. "*in insertModMenuePageSideLine* ".. error13;
	elseif string.lower(args.pageType) == "master" then
		local mod = args.modMenueTable;
		local modTable = g_currentMission.guiMenue.modTable[mod];
		local masterPage = args.masterPage;
		if modTable.page[masterPage].side == nil then modTable.page[masterPage].side = {};end;		
		if args.pageSide ~= nil and modTable.page[masterPage].side[args.pageSide] ~= nil then				
			local pageSide = args.pageSide;
			table.insert(modTable.page[masterPage].side, pageSide, {});			
			modTable.page[masterPage].side[pageSide].name = args.pageSideName or "Master Page Side ".. tostring(pageSide);
			modTable.page[masterPage].side[pageSide].globalName = args.pageSideGlobalName or "masterPageSide".. tostring(pageSide);
			modTable.page[masterPage].side[pageSide].onOpenCallback = args.onOpenCallback;
			modTable.page[masterPage].side[pageSide].onCloseCallback = args.onCloseCallback;
			modTable.page[masterPage].side[pageSide].line = {};
			modTable.page[masterPage].side[pageSide].viewLines = {maxLine=1, bounds={1, 1}};
			isGenerate = true;
		else
			modTable.page[masterPage].side[#modTable.page[masterPage].side+1] = {};			
			local pageSide = #modTable.page[masterPage].side;
			modTable.page[masterPage].side[pageSide].name = args.pageSideName or "Master Page Side ".. tostring(pageSide);
			modTable.page[masterPage].side[pageSide].globalName = args.pageSideGlobalName or "masterPageSide".. tostring(pageSide);
			modTable.page[masterPage].side[pageSide].onOpenCallback = args.onOpenCallback;
			modTable.page[masterPage].side[pageSide].onCloseCallback = args.onCloseCallback;
			modTable.page[masterPage].side[pageSide].line = {};
			modTable.page[masterPage].side[pageSide].viewLines = {maxLine=1, bounds={1, 1}};
			isGenerate = true;
		end;		
	elseif string.lower(args.pageType) == "slave" then
		local mod = args.modMenueTable;
		local modTable = g_currentMission.guiMenue.modTable[mod];
		local masterPage = args.masterPage;
		local slavePage = args.slavePage;
		if modTable.page[masterPage].page[slavePage].side == nil then modTable.page[masterPage].page[slavePage].side = {};end;
		if args.pageSide ~= nil and modTable.page[masterPage].page[slavePage].side[args.pageSide] ~= nil then
			local pageSide = args.pageSide;
			table.insert(modTable.page[masterPage].page[slavePage].side, pageSide, {});			
			modTable.page[masterPage].page[slavePage].side[pageSide].name = args.pageSideName or "Master Page Side ".. tostring(pageSide);
			modTable.page[masterPage].page[slavePage].side[pageSide].globalName = args.pageSideGlobalName or "masterPageSide".. tostring(pageSide);
			modTable.page[masterPage].page[slavePage].side[pageSide].onOpenCallback = args.onOpenCallback;
			modTable.page[masterPage].page[slavePage].side[pageSide].onCloseCallback = args.onCloseCallback;
			modTable.page[masterPage].page[slavePage].side[pageSide].line = {};
			modTable.page[masterPage].page[slavePage].side[pageSide].viewLines = {maxLine=1, bounds={1, 1}};
			isGenerate = true;
		else
			modTable.page[masterPage].page[slavePage].side[#modTable.page[masterPage].page[slavePage].side+1] = {};
			local pageSide = #modTable.page[masterPage].page[slavePage].side;					
			modTable.page[masterPage].page[slavePage].side[pageSide].name = args.pageSideName or "Master Page Side ".. tostring(pageSide);
			modTable.page[masterPage].page[slavePage].side[pageSide].globalName = args.pageSideGlobalName or "masterPageSide".. tostring(pageSide);
			modTable.page[masterPage].page[slavePage].side[pageSide].onOpenCallback = args.onOpenCallback;
			modTable.page[masterPage].page[slavePage].side[pageSide].onCloseCallback = args.onCloseCallback;
			modTable.page[masterPage].page[slavePage].side[pageSide].line = {};
			modTable.page[masterPage].page[slavePage].side[pageSide].viewLines = {maxLine=1, bounds={1, 1}};
			isGenerate = true;
		end;
	end;
	return isGenerate, errorTxt;
end;

function guiSetGetMenue:generateModMenuePageSideLine(...) --for master page Side Line and slave page Side Line	
	if ... == nil or type(...) ~= "table" then return false, error0.. "*in generateModMenuePageSideLine* ".. error10;end;
	local args = ...;	
	local isGenerate, errorTxt = true, "";
	local maxButtonDefault = g_currentMission.guiMenue.maxButtonLine;
	if args.modMenueTable == nil or (args.modMenueTable ~= nil and type(args.modMenueTable) ~= "number") or g_currentMission.guiMenue.modTable[args.modMenueTable] == nil or not g_currentMission.guiMenue.modTable[args.modMenueTable].isGenerate then 
		errorTxt = error0.. "*in generateModMenuePageLine* ".. error3;
		isGenerate = false;	
	elseif (args.masterPage ~= nil and type(args.masterPage) ~= "number") or (args.slavePage ~= nil and type(args.slavePage) ~= "number") or (args.pageSide ~= nil and type(args.pageSide) ~= "number") or
			(args.slavePage ~= nil and args.masterPage == nil) or (args.pageSide ~= nil and args.masterPage == nil) or (args.pageSide ~= nil and args.slavePage ~= nil and args.masterPage == nil) or
			(args.masterPage ~= nil and g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage]) == nil or (args.line ~= nil and type(args.line) ~= "number") or (args.maxButton ~= nil and type(args.maxButton) ~= "number") then
			errorTxt = error0.. "*in generateModMenuePageSideLine* ".. error11;
	elseif args.lineButtonTable == nil or (args.lineButtonTable ~= nil and type(args.lineButtonTable) ~= "table") then
		errorTxt = error0.. "*in generateModMenuePageSideLine* ".. error12;
		isGenerate = false;
	else	
		local mod = args.modMenueTable;
		local modTable = g_currentMission.guiMenue.modTable[mod];
		local masterPage = args.masterPage or #modTable.page;
		local slavePage = args.slavePage or 1;
		local pageSide = args.pageSide or 1;
		local pageType = modTable.page[masterPage].pageType;
		local line = args.line or 1;
		local pageLine = nil; --default
		--print("".. tostring().. "args masterpage= ".. tostring(args.masterPage).. " -pageType".. tostring(pageType))
		if pageType == "modMasterPageSide" then
			pageSide = args.pageSide or #modTable.page[masterPage].side;
			if modTable.page[masterPage].side[pageSide] == nil then return false, error0.. "*in generateModMenuePageSideLine* master/pageSide not found";end;
			if modTable.page[masterPage].side[pageSide].line == nil then modTable.page[masterPage].side[pageSide].line = {};end;
			if args.line == nil then line = #modTable.page[masterPage].side[pageSide].line;end;
			if (args.replaceLine == nil or not args.replaceLine) and modTable.page[masterPage].side[pageSide].line[line] ~= nil then --double found
				args = nil;return false, error0.. "*in generateModMenuePageSideLine* ".. error5;
			elseif args.replaceLine and modTable.page[masterPage].side[pageSide].line[line] == nil then --not found
				args = nil;return false, error0.. "*in generateModMenuePageSideLine* Not found replace master page side line ".. tostring(line);
			elseif args.replaceLine and modTable.page[masterPage].side[pageSide].line[line] ~= nil then --replace line
			
			end;
			if modTable.page[masterPage].side[pageSide].line[line] == nil then modTable.page[masterPage].side[pageSide].line[line] = {};end;
			--modTable.page[masterPage].side[pageSide].viewLines = {maxLine=1, bounds={1, 1}};
			pageLine = modTable.page[masterPage].side[pageSide].line[line];
		else
			slavePage = #modTable.page[masterPage].page; 
			pageSide = args.pageSide or #modTable.page[masterPage].page[slavePage].side;
			if modTable.page[masterPage].page[slavePage].side[pageSide] == nil then return false, error0.. "*in generateModMenuePageSideLine* slave/pageSide not found";end;
			if args.line == nil then line = #modTable.page[masterPage].page[slavePage].side[pageSide].line;end;
			if (args.replaceLine == nil or not args.replaceLine) and modTable.page[masterPage].page[slavePage].side[pageSide].line[line] ~= nil then --double found
				args = nil;return false, error0.. "*in generateModMenuePageSideLine* ".. error5;
			elseif args.replaceLine and modTable.page[masterPage].page[slavePage].side[pageSide].line[line] == nil then --not found
				args = nil;return false, error0.. "*in generateModMenuePageSideLine* Not found replace slave page side line ".. tostring(line);
			elseif args.replaceLine and modTable.page[masterPage].page[slavePage].side[pageSide].line[line] ~= nil then --replace line
			
			end;
			if modTable.page[masterPage].page[slavePage].side[pageSide].line[line] == nil then modTable.page[masterPage].page[slavePage].side[pageSide].line[line] = {};end;
			--modTable.page[masterPage].page[slavePage].side[pageSide].viewLines = {maxLine=1, bounds={1, 1}};
			pageLine = modTable.page[masterPage].page[slavePage].side[pageSide].line[line];
		end;		
		
		
		--if args.pageSide ~= nil and args.slavePage ~= nil then ---line in SlavePage and Side			
			--g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage].page[args.slavePage].side[args.pageSide].line[args.line] = {};
			--g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage].page[args.slavePage].side[args.pageSide].viewLines = {maxLine=1, bounds={1, 1}};
			--pageLine = g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage].page[args.slavePage].side[args.pageSide].line[args.line];		
		--else --line in MasterPage
			--g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage].side[args.pageSide].line[args.line] = {};		
			--g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage].side[args.pageSide].viewLines = {maxLine=1, bounds={1, 1}};		
			--pageLine = g_currentMission.guiMenue.modTable[args.modMenueTable].page[args.masterPage].side[args.pageSide].line[args.line];
		--end;
		local buttonTable = args.lineButtonTable;			
		pageLine.isHidden = args.isHidden or false;
		pageLine.buttonAutoWidth = args.buttonAutoWidth or true;
		pageLine.maxButton = args.maxButtons or 0;
		pageLine.helpIconAtLine = false;
		if pageLine.maxButton == 0 then pageLine.isHidden = true;end; --auto hidden is args.maxButtons 0 and args.isHidden false
		if pageLine.maxButton > maxButtonDefault then pageLine.maxButton = maxButtonDefault;end;
		--if pageLine.maxButton > #buttonTable then pageLine.maxButton = #buttonTable;end;
		if pageLine.button == nil then pageLine.button = {};end;
		if buttonTable == nil then 
			errorTxt = tostring(g_currentMission.guiMenue.master.metadata.title).. " Error (Line ".. tostring(args.line).. " ButtonTable (min 1-6 max) generate) <-- not found !!!";
			return false, errorTxt;
		else		
			for a=1, #buttonTable do				
				if buttonTable[a] ~= nil then
					if pageLine.button[a] == nil then pageLine.button[a] = {};end;
					pageLine.button[a].isHidden = buttonTable[a].isHidden or false;
					if buttonTable[a].buttonType > #g_currentMission.guiMenue.default.buttonType or g_currentMission.guiMenue.default.buttonType[buttonTable[a].buttonType] == nil then 
						pageLine.button[a].typ = 0;						
					else
						pageLine.button[a].typ = buttonTable[a].buttonType;						
					end;
					if buttonTable[a].returnClick == nil and pageLine.button[a].typ > 0 then
						pageLine.button[a].returnClick = "lineAndButton".. tostring(a);
					elseif buttonTable[a].returnClick ~= nil and pageLine.button[a].typ > 0 then
						pageLine.button[a].returnClick = buttonTable[a].returnClick;
					else
						pageLine.button[a].returnClick = "lineAndButton".. tostring(a);
					end;
					pageLine.button[a].width = tonumber(buttonTable[a].buttonWidth) or 0;				
					pageLine.button[a].borderColor = buttonTable[a].borderColor or nil;
					pageLine.button[a].txtOverButton = buttonTable[a].txtOverButton or "";
					pageLine.button[a].txtOverButtonColor = buttonTable[a].txtOverButtonColor or nil;
					pageLine.button[a].txtUnderButton = buttonTable[a].txtUnderButton or "";
					pageLine.button[a].txtUnderButtonColor = buttonTable[a].txtUnderColor or nil;
					pageLine.button[a].infoTxt = buttonTable[a].infoTxt or "";
					pageLine.button[a].helpIcon = buttonTable[a].helpIcon or 0;
					if pageLine.button[a].helpIcon ~= nil and pageLine.button[a].helpIcon > 0 then
						pageLine.helpIconAtLine = true;
						pageLine.button[a].helpTxt = {};
						for b=1, pageLine.button[a].helpIcon do
							pageLine.button[a].helpTxt[b] = buttonTable[a].helpTxt[b] or "!! Not Found Help Text !!";
						end;					
					end;
					pageLine.button[a].buttonTxt = buttonTable[a].buttonTxt or "";
					pageLine.button[a].buttonTxtAndCmd = buttonTable[a].buttonTxtAndCmd or false;					
					pageLine.button[a].moveButtonTxt = buttonTable[a].moveButtonTxt or false;
					pageLine.button[a].moveTxt = {bounds={0,0}, posX=0, waitMove=0, lastFirstPosX=0, lastEndPosX=0, lastMaxWidth=0}; --lastFirst/EndPosX.... for zoom or not					
					pageLine.button[a].modOnlyInfo = buttonTable[a].modOnlyInfo; --only for mod alone (to deposit something) -button
					pageLine.button[a].changeAlone = buttonTable[a].changeAlone or false; 
					pageLine.button[a].cmdType = buttonTable[a].cmdType or "";
					pageLine.button[a].cmdTable = buttonTable[a].cmdTable or nil;					
					if buttonTable[a].cmdType ~= nil and string.find(buttonTable[a].cmdType, "pullDown") then
						if string.find(buttonTable[a].cmdType, "pullDown_") then
							pageLine.button[a].maxSelect = tonumber(Utils.getNoNil(string.gsub(buttonTable[a].cmdType, "pullDown_", ""), 1));
						else
							pageLine.button[a].maxSelect = 1;
						end;
					end;
					pageLine.button[a].cmdValue = buttonTable[a].cmdValue or "";
				end;
			end;			
		end;		
		isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:setMaxViewLineAtPage(false, mod, masterPage, slavePage, pageSide);		
	end;	
	return isGenerate, errorTxt;
end;

function guiSetGetMenue:setMaxViewLineAtPage(allPages, modMenueTable, modMasterPage, modSlavePage, modSidePage)	--later new function !?! 
	local helpIconHeight = g_currentMission.guiMenue.overlays["buttonDragDrop"].height/2;
	local linePosY = g_currentMission.guiMenue.overlays["groundSlave"].y+g_currentMission.guiMenue.overlays["groundSlave"].height;
	local lineHeight = g_currentMission.guiMenue.overlays["buttonDragDrop"].height*2+(g_currentMission.guiMenue.default.verticalTxtDistance*2);
	local endPosY = g_currentMission.guiMenue.overlays["groundSlave"].y+lineHeight;
	local foundMoreLines = false;
	local modTable = nil;	
	local modPageType = guiSetGetMenue:getPageType(modMenueTable, modMasterPage, modSlavePage);	
	if modPageType ~= nil and (allPages == nil or not allPages) then
		if modPageType == "modMasterPageSide" and modSidePage ~= nil then modTable = g_currentMission.guiMenue.modTable[modMenueTable].page[modMasterPage].side[modSidePage];		
		elseif modPageType == "modSlavePageSide" and modSidePage ~= nil then modTable = g_currentMission.guiMenue.modTable[modMenueTable].page[modMasterPage].page[modSlavePage].side[modSidePage];
		else return false, "!! ERROR !! Gui Menue -MaxViewLines for a ModPage- not generate";end;		
		for a=1, #modTable.line do
			if modTable.line[a].helpIconAtLine then 
				linePosY = linePosY-lineHeight-helpIconHeight;
			else	
				linePosY = linePosY-lineHeight;
			end;
			if linePosY < endPosY or linePosY == endPosY then
				modTable.viewLines.maxLine = a-1;
				modTable.viewLines.bounds[1] = 1;
				modTable.viewLines.bounds[2] = a-1;				
				foundMoreLines = true;
				break;
			end;			
		end;
		if not foundMoreLines then
			modTable.viewLines.maxLine = #modTable.line;
			modTable.viewLines.bounds[1] = 1;
			modTable.viewLines.bounds[2] = #modTable.line;	
		end;
		return true, "";		
	end;	
	if allPages ~= nil and allPages then		
		for a=1, #g_currentMission.guiMenue.modTable do
			local lastMasterPage = g_currentMission.guiMenue.modTable[a].lastOpenPage.masterPage;
			local lastSlavePage = g_currentMission.guiMenue.modTable[a].lastOpenPage.slavePage;
			local lastPageSide = g_currentMission.guiMenue.modTable[a].lastOpenPage.pageSide;
			local modPageTable = g_currentMission.guiMenue.modTable[a];
			--pageType "modMasterPageSide"				
			if modPageTable ~= nil and modPageTable.page ~= nil and #modPageTable.page > 0 and modPageTable.page[lastMasterPage] ~= nil and modPageTable.page[lastMasterPage].side ~= nil and #modPageTable.page[lastMasterPage].side > 0 then
				for b=1, #modPageTable.page[lastMasterPage].side do
					local modPageSideTable = modPageTable.page[lastMasterPage].side[b];
					if modPageSideTable ~= nil and #modPageSideTable > 0 and modPageSideTable.line ~= nil and #modPageSideTable.line > 0 then
						for c=1, #modPageSideTable.line do
							if modPageSideTable.line[c] ~= nil and #modPageSideTable.line[c] > 0 then
								if modPageSideTable.line[c].helpIconAtLine then 
									linePosY = linePosY-lineHeight-helpIconHeight;
								else	
									linePosY = linePosY-lineHeight;
								end;
								if linePosY < endPosY or linePosY == endPosY then
									modPageSideTable.viewLines.maxLine = c-1;
									modPageSideTable.viewLines.bounds[1] = 1;
									modPageSideTable.viewLines.bounds[2] = c-1;				
									foundMoreLines = true;
									break;
								end;
							end;
						end;
						if not foundMoreLines then
							modPageSideTable.viewLines.maxLine = #modPageSideTable.line;
							modPageSideTable.viewLines.bounds[1] = 1;
							modPageSideTable.viewLines.bounds[2] = #modPageSideTable.line;	
						end;
					end;
				end;
			end;
			--pageType "modMasterPageSide"
			--pageType "modSlavePageSide"
			modPageTable = g_currentMission.guiMenue.modTable[a].page[lastMasterPage];
			if modPageTable ~= nil and modPageTable.page ~= nil and #modPageTable.page > 0 and modPageTable.page[lastMasterPage] ~= nil and modPageTable.page[lastMasterPage].side ~= nil and #modPageTable.page[lastMasterPage].side > 0 then
				for b=1, #modPageTable.page[lastMasterPage].side do
					local modPageSideTable = modPageTable.page[lastMasterPage].side[b];
					if modPageSideTable ~= nil and #modPageSideTable > 0 and modPageSideTable.line ~= nil and #modPageSideTable.line > 0 then
						for c=1, #modPageSideTable.line do
							if modPageSideTable.line[c] ~= nil and #modPageSideTable.line[c] > 0 then
								if modPageSideTable.line[c].helpIconAtLine then 
									linePosY = linePosY-lineHeight-helpIconHeight;
								else	
									linePosY = linePosY-lineHeight;
								end;
								if linePosY < endPosY or linePosY == endPosY then
									modPageSideTable.viewLines.maxLine = c-1;
									modPageSideTable.viewLines.bounds[1] = 1;
									modPageSideTable.viewLines.bounds[2] = c-1;				
									foundMoreLines = true;
									break;
								end;
							end;
						end;
						if not foundMoreLines then
							modPageSideTable.viewLines.maxLine = #modPageSideTable.line;
							modPageSideTable.viewLines.bounds[1] = 1;
							modPageSideTable.viewLines.bounds[2] = #modPageSideTable.line;	
						end;
					end;
				end;
			end;
			--pageType "modSlavePageSide"
		end;
		--pageType Mods masterPageSide/slavePageSide and Line
		return true, "";		
	end;
	return false, "!! ERROR !! Gui Menue -MaxViewLines for a ModPage- not generate";
end;

function guiSetGetMenue:getPageType(modMenueTable, masterPage, slavePage)	
	if modMenueTable == nil or g_currentMission.guiMenue.modTable[modMenueTable] == nil then return nil;end;
	if masterPage == nil then masterPage = g_currentMission.guiMenue.modTable[modMenueTable].lastOpenPage.masterPage;end;
	if slavePage == nil then slavePage = g_currentMission.guiMenue.modTable[modMenueTable].lastOpenPage.slavePage;end;
	if g_currentMission.guiMenue.modTable[modMenueTable].page ~= nil and g_currentMission.guiMenue.modTable[modMenueTable].page[masterPage] ~= nil then
		if g_currentMission.guiMenue.modTable[modMenueTable].page[masterPage].page == nil and g_currentMission.guiMenue.modTable[modMenueTable].page[masterPage].side ~= nil then --and #g_currentMission.guiMenue.modTable[modMenueTable].page[masterPage].side > 0 then		
			return "modMasterPageSide";		
		elseif g_currentMission.guiMenue.modTable[modMenueTable].page[masterPage].page ~= nil and g_currentMission.guiMenue.modTable[modMenueTable].page[masterPage].page[slavePage] ~= nil and g_currentMission.guiMenue.modTable[modMenueTable].page[masterPage].page[slavePage].side ~= nil then --and #g_currentMission.guiMenue.modTable[modMenueTable].page[masterPage].page[slavePage].side > 0 then		
			return "modSlavePageSide";		
		end;
	end;
	return nil;
end;

function guiSetGetMenue:reloadMoveTxtBounds(modMenueTable ,lineTable) --zoom in/out reset this or problem with text
	if lineTable ~= nil then
	
	end;
end;