guiMenueGenerate = {};

source(MultiOverlayV3.modDir.."scripte/moGuiMenue/moGuiMenueClick.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/moSetGetCallbacksGuiMenue.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/globalSettingsSide1.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/tabletPdaDefaultSide1.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/tabletPdaDefaultSide2.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/tabletPdaDefaultSide3.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/pdaSlotGlobalSide1.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/pdaSlotGlobalSide2.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/appGlobalSettingsSide1.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/otherSettingsSide1.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/slotSettingsSide1.lua");
source(MultiOverlayV3.modDir.."scripte/moGuiMenue/moduleMohSettingsSide1.lua");

function guiMenueGenerate:addGuiMenue(self)
	if g_currentMission.guiMenue ~= nil then
		MultiOverlayV3.guiMenue = {}; --optionalName for your Mod or ...
		local isGenerate, isUpToDate, installModGuiTablePos, infoTxt = guiMenueGenerate:modMenue(self);
		if isGenerate and installModGuiTablePos > 0 then
			print(tostring(MultiOverlayV3.metadata.title).. " generate GuiMenue Pages (".. tostring(infoTxt).. ")")			
			MultiOverlayV3.guiMenue.on = false; --is not found at MultiOverlayV3 then error and not open settings pages
			guiMenueGenerate:masterPage(self, installModGuiTablePos);			
		elseif installModGuiTablePos == 0 then
			print("!! ERROR !! GuiMenue for ".. tostring(MultiOverlayV3.metadata.title).. " not loaded (found not Mod Menue Position)")			
		end;		
	end;
end;

function guiMenueGenerate:modMenue(self)
	local isGenerate, isUpToDate, installModGuiTablePos, errorTxt, infoTxt = false, false, 0, "", "";
	function printError()
		if not isGenerate then print(tostring(errorTxt));end;
	end;	
	--{modGuiMenueVersion=, modMenueName=, onOpenCallback=, onCloseCallback=, onSaveCallback=, modVersion=, modAuthor=}
	isGenerate, isUpToDate, installModGuiTablePos, errorTxt, infoTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenue( {modGuiMenueVersion=guiMenue.metadata.guiMenueVersion, modMenueName=tostring(MultiOverlayV3.metadata.title), modVersion=tostring(MultiOverlayV3.metadata.version), modAuthor=tostring(MultiOverlayV3.metadata.author), onOpenCallback=moSetGetCallbacksGuiMenue.onOpenCallback, onCloseCallback=moSetGetCallbacksGuiMenue.onCloseCallback, onSaveCallback=moSetGetCallbacksGuiMenue.setSave} );
	--isGenerate true or false(not generateGuiMenue) is false give errorTxt(string)
	printError();
	return isGenerate, isUpToDate, installModGuiTablePos, infoTxt;	
end;

function guiMenueGenerate:masterPage(self, installModGuiTablePos)
	local isGenerate, errorTxt = true, "";
	function printError()
		if not isGenerate and string.len(tostring(errorTxt)) > 0 then print(tostring(errorTxt));end;
	end;
	-----------------masterpage 1, total-----------------
	--masterpage 1 global settings
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePage( {modMenueTable=installModGuiTablePos, pageType="master", masterPageName="Global Settings", masterPageGlobalName="globalSettings_", onOpenCallback=moSetGetCallbacksGuiMenue.setOpenSelectPDA} );
	printError();
	--masterpage 1, global settings
	--side 1
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="master", pageSideName="Global Settings/ Moh", pageSideGlobalName="globalSettingsSide1_"} );
	printError();
	--side 1
	--side 1 lines
	if isGenerate then globalSettingsSide1:generate(installModGuiTablePos, 1, 1, 1);end;
	--side 1 lines
	-----------------masterpage 1, total-----------------
	
	-----------------masterpage 2, total-----------------
	--masterpage 2 global settings
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePage( {modMenueTable=installModGuiTablePos, pageType="master", masterPageName="PDAs/SLOTs Generate", masterPageGlobalName="pdaSlotGlobal_"} );
	printError();
	--masterpage 2 global settings
	--side 1
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="master", pageSideName="PDAs/SLOTs Generate", pageSideGlobalName="pdaSlotGlobalSide1_"} );
	printError();
	--side 1
	--side 1 lines
	if isGenerate then pdaSlotGlobalSide1:generate(installModGuiTablePos, 2, 1, 1);end;
	--side 1 lines
	-----------------masterpage 2, total-----------------
	
	
	function comp(w1,w2)			
		if w1[1] < w2[1] then
			return true;
		end;			
	end;	
	-----------------masterpage 3, total-----------------
	--masterpage 3, slavepage 1, Tablet PDAs (pageType slave, generate automatic first master page)
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePage( {modMenueTable=installModGuiTablePos, pageType="slave", masterPageName="Tablet PDAs", masterPageGlobalName="tabletPDAs_", slavePageName="Master PDA", slavePageGlobalName="masterPDA_", onOpenCallback=moSetGetCallbacksGuiMenue.setOpenSelectPDA} );				
	printError();
	--masterpage 3, slavepage 1, Tablet PDAs
	--side 1
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="slave", pageSideName="Master PDA", pageSideGlobalName="tabletPdaDefaultSide1_",} );		
	printError();
	--side 1
	--side 1 lines
	if isGenerate then tabletPdaDefaultSide1:generate(installModGuiTablePos, "masterPDA_", 3, 1, 1);end;
	--side 1 lines
	--side 2
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="slave", pageSideName="Master PDA", pageSideGlobalName="tabletPdaDefaultSide2_",} );		
	printError();
	--side 2
	--side 2 lines
	if isGenerate then tabletPdaDefaultSide2:generate(installModGuiTablePos, "masterPDA_", 3, 1, 2);end;
	--side 2 lines
	--side 3
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="slave", pageSideName="Master PDA", pageSideGlobalName="tabletPdaDefaultSide3_",} );		
	printError();
	--side 3
	--side 3 lines
	if isGenerate then tabletPdaDefaultSide3:generate(installModGuiTablePos, "masterPDA_", 3, 1, 3);end;
	--side 3 lines
	--masterpage 3, slavepage 1, Tablet PDAs
	--masterpage 3, slavepage 2 - ..., side 1 - ... and lines
	local foundMohPDAs = moSetGetMohPDA:getPDAs();	
	if foundMohPDAs ~= nil and #foundMohPDAs > 0 then		
		table.sort(foundMohPDAs, comp);
		for a=1, #foundMohPDAs do
			if not string.find(foundMohPDAs[a][1], "masterPDA_") then
				local whichPdaName = Utils.getNoNil(moSetGetOverlays.pda[foundMohPDAs[a][1]].name, "");
				if string.len(whichPdaName) < 1 then whichPdaName = tostring(foundMohPDAs[a][1]);end;
				isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenueSlavePage( {modMenueTable=installModGuiTablePos, masterPage=3, slavePageName=tostring(whichPdaName), slavePageGlobalName=tostring(foundMohPDAs[a][1])} );	
				printError();
				isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="slave", pageSideName=tostring(whichPdaName), pageSideGlobalName="tabletPdaDefaultSide1_"} );
				if isGenerate then tabletPdaDefaultSide1:generate(installModGuiTablePos, tostring(foundMohPDAs[a][1]), 3, #g_currentMission.guiMenue.modTable[installModGuiTablePos].page[#g_currentMission.guiMenue.modTable[installModGuiTablePos].page].page, 1);end; 
				
				
				isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="slave", pageSideName=tostring(whichPdaName), pageSideGlobalName="tabletPdaDefaultSide2_"} );
				if isGenerate then tabletPdaDefaultSide2:generate(installModGuiTablePos, tostring(foundMohPDAs[a][1]), 3, #g_currentMission.guiMenue.modTable[installModGuiTablePos].page[#g_currentMission.guiMenue.modTable[installModGuiTablePos].page].page, 2);end;
				
				isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="slave", pageSideName=tostring(whichPdaName), pageSideGlobalName="tabletPdaDefaultSide3_"} );
				if isGenerate then tabletPdaDefaultSide3:generate(installModGuiTablePos, tostring(foundMohPDAs[a][1]), 3, #g_currentMission.guiMenue.modTable[installModGuiTablePos].page[#g_currentMission.guiMenue.modTable[installModGuiTablePos].page].page, 3);end;
			end;
		end;					
	end;
	--masterpage 3, slavepage 2 - ..., side 1 - ... and lines	
	-----------------masterpage 3, total-----------------
	
	-----------------masterpage 4, total-----------------
	--masterpage 1 slot settings
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePage( {modMenueTable=installModGuiTablePos, pageType="master", masterPageName="Slot Settings", masterPageGlobalName="slotSettings_",} );		
	printError();
	--masterpage 1, slot settings
	--side 1
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="master", pageSideName="Side 1", pageSideGlobalName="slotSettingsSide1_",} );		
	printError();
	--side 1
	--side 1 lines
	if isGenerate then slotSettingsSide1:generate(installModGuiTablePos, 4, 1, 1);end;
	--side 1 lines
	-----------------masterpage 4, total-----------------
	
	-----------------masterpage 5, total-----------------
	--masterpage 1 module settings
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePage( {modMenueTable=installModGuiTablePos, pageType="master", masterPageName="Module(Moh) Settings", masterPageGlobalName="moduleMohSettings_",} );		
	printError();
	--masterpage 1, module settings
	--side 1
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="master", pageSideName="Side 1", pageSideGlobalName="moduleMohSettingsSide1_",} );		
	printError();
	--side 1
	--side 1 lines
	if isGenerate then moduleMohSettingsSide1:generate(installModGuiTablePos, 5, 1, 1);end;
	--side 1 lines
	-----------------masterpage 5, total-----------------
	
	-----------------masterpage 6, total-----------------
	--masterpage 1 other settings
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePage( {modMenueTable=installModGuiTablePos, pageType="master", masterPageName="Other Settings", masterPageGlobalName="otherSettings_",} );		
	printError();
	--masterpage 1, other settings
	--side 1
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSide( {modMenueTable=installModGuiTablePos, pageType="master", pageSideName="Side 1", pageSideGlobalName="otherSettingsSide1_",} );		
	printError();
	--side 1
	--side 1 lines
	if isGenerate then otherSettingsSide1:generate(installModGuiTablePos, 6, 1, 1);end;
	--side 1 lines
	-----------------masterpage 6, total-----------------
	
	
	--test page
	--setTestGlobalSettings(installModGuiTablePos, #g_currentMission.guiMenue.modTable[installModGuiTablePos].page, 1, 1)
	--test page	
	--if not g_currentMission.guiMenue.modTable[installModGuiTablePos].isGenerate then MultiOverlayV3.guiMenue.on = nil;end; --is not found at MultiOverlayV3 then error and not open settings pages
	g_currentMission.guiMenue.guiSetGet:modSaveButtonInfo(installModGuiTablePos);
	--for key, value in pairs(g_currentMission.guiMenue.modTable[installModGuiTablePos].getButtonInfo) do
		--print("button info key und value ...".. tostring(key).. "-----".. tostring(value))
		--for key1, value1 in pairs(value) do
		--	print("button info under table key1 und value1 ...".. tostring(key1).. "-----".. tostring(value1))
		--	for key2, value2 in pairs(value1) do
		--		print("button info under under table key1 und value1 ...".. tostring(key2).. "-----".. tostring(value2))
		--	end;
		--end;
	--end;
end;

function guiMenueGenerate:insertNewTabletPdaPage(pdaName, pdaGlobalName) --over pdaSlotGlobalSide1	
	local installModGuiTablePos = MultiOverlayV3.guiMenue.modTable;
	local isGenerate, errorTxt = true, "";
	function printError()
		if not isGenerate and string.len(tostring(errorTxt)) > 0 then print(tostring(errorTxt));end;
	end;
	
	--default slavePage insert in Tablet PDAs
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenueSlavePage( {modMenueTable=installModGuiTablePos, masterPage=3, slavePageName=tostring(pdaName), slavePageGlobalName=tostring(pdaGlobalName)} );	
	printError();	
	--default slavePage insert in Tablet PDAs
	
	local slavePageTotal = #g_currentMission.guiMenue.modTable[installModGuiTablePos].page[3].page;
	
	--default side 1 and lines	
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:insertModMenuePageSide( {modMenueTable=installModGuiTablePos, masterPage=3, slavePage=slavePageTotal, pageType="slave", pageSideName=tostring(pdaName), pageSideGlobalName="tabletPdaDefaultSide1_",} );		
	printError();	
	tabletPdaDefaultSide1:generate(installModGuiTablePos, tostring(pdaGlobalName), 3, slavePageTotal, 1); --lines
	--default side 1 and lines
	
	--default side 2 and lines
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:insertModMenuePageSide( {modMenueTable=installModGuiTablePos, masterPage=3, slavePage=slavePageTotal, pageType="slave", pageSideName=tostring(pdaName), pageSideGlobalName="tabletPdaDefaultSide2_",} );		
	printError();
	tabletPdaDefaultSide2:generate(installModGuiTablePos, tostring(pdaGlobalName), 3, slavePageTotal, 2); --lines	
	--default side 2 and lines
	--default side 3 and lines
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:insertModMenuePageSide( {modMenueTable=installModGuiTablePos, masterPage=3, slavePage=slavePageTotal, pageType="slave", pageSideName=tostring(pdaName), pageSideGlobalName="tabletPdaDefaultSide3_",} );		
	printError();
	tabletPdaDefaultSide3:generate(installModGuiTablePos, tostring(pdaGlobalName), 3, slavePageTotal, 3); --lines	
	--default side 3 and lines
end;

function guiMenueGenerate:generateGuiMenuePageLine(self, installModGuiTablePos)	--old
	
	--setGlobalSettings(installModGuiTablePos);
	--setMohPdaSettings(installModGuiTablePos);	
	
	--local lineButtonTable = {};	
	--lineButtonTable[#lineButtonTable+1] = {
	--	returnClick = "globalZoomInOut_"; --optional better for whatClick Player at GuiMenue, (Default lineAndButton with Up or Down is buttonType = ...UpDown or ...LeftRight) Bsp: globalZoomInOut_Up is returnClick (or Default line1_button2_Up for line 1 button 2 and Up returnClick) !! Attention check returnClick is line1_button2_  and not line1_button2 !! ---->if your Mod Menue open and if string.len(g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick.name) > 0 then ...... end --> reset returnClick with--> g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick = {name="",line=0,button=0, pullDownOpen=false, pullDownLine=0}; ---> or check if g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick.line == .. or/and if g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick.button == ..
	--	isHidden = false; --set true and button is hidden
	--	buttonType = 3; --integer see g_currentMission.guiMenue.default.buttonType; 0 = blank Button for section or title text etc.
	--	buttonWidth = 0; --optional -10 - 10 (test and check for optimal value all Buttons set optional autoButtonWidth) Default is 0
	--	borderColor = moSetGetExtras.colors["darkGreen"]; --optional set Border Color for Button (R,G,B,A) a table, can marker a new option/value or etc.
	--	txtOverButton = "Zoom In/Out"; --string
	--	txtOverButtonColor = moSetGetExtras.colors["darkGreen"]; --optional set Color for over Button Text (R,G,B,A) a table, can marker a new option/value or etc.
	--	helpIcon = 1; --integer (optional)
	--	helpTxt = {"Min zoomIn ".. tostring(moSetGetOverlays.minZoomOutInTemp).. "\nDefault zoomInOut ".. tostring(moSetGetOverlays.defaultZoomOutInTemp).. "\nMax zoomOut ".. tostring(moSetGetOverlays.maxZoomOutInTemp)}; --is helpIcon then set Help Text (optional) --string
	--	infoTxt = "Min/Max ZoomInOut for MiniPDAs"; --string		
	--	cmdTable = moSetGetOverlays; --your mod a string,tabel value or etc. --cmdType = pullDown then cmd value list string {moSetGetOverlays[1] = {cmdTable= .., cmdValue= .., cmdType=.., buttonTxt=.., isSelect=true/false}, moSetGetOverlays[2]..., moSetGetOverlays[3]...} etc.	
	--  !! if cmdTable a table then reset table is click Button and set new table etc. value 1 is text at button if buttonTxt nil or blank !!
	--	cmdValue = "zoomOutInTemp"; --string, if cmdTable a table then ignore cmdValue
	--	cmdType = "int"; --string (int,float,boolean,string,stringOnly,money,pullDown_1) --stringOnly = then set buttonTxt at button, --pullDown_INT = int maxSelect is open pullDownMenue
	--	buttonTxt = 0.1; --string/int/float (float bsp: 4.3) value a cmd moSetGetOverlays.zoomOutInTemp, if int then ignore buttonTxt Value		
	--};	
	--g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine(MultiOverlayV3.guiMenue.modTable, 2, 1, 4, false, lineButtonTable, false);
	
	--g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine(MultiOverlayV3.guiMenue.modTable, 1, 2, 2, false);
	--g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine(MultiOverlayV3.guiMenue.modTable, 1, 3, 2, false);		
	--!! set/replace/delete or add later a (or new) line then reset maxViewLinePage at GuiMenue with ---->g_currentMission.guiMenue.master:resetPage(MultiOverlayV3.guiMenue.modTable, modPage)  !!
	--!! to change all values later !!
end;

function setTestGlobalSettings(installModGuiTablePos, masterPage, slavePage, pageSide)
	----is a pullDownMenue ---> check is pullDownOpen or not --> g_currentMission.guiMenue.master.isPullDownOpen()		
	local isGenerate, errorTxt = true, "";
	function printError()
		if not isGenerate and string.len(tostring(errorTxt)) > 0 then print(tostring(errorTxt));end;
	end;	
	local lineButtonTable = {};	
	local lineCmdTable = {};
	--line 1
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "testMohV3On_";  
		isHidden = false; 
		buttonType = 7; 
		buttonWidth = 0; 		
		txtOverButton = "MOH V3 Mod"; 
		helpIcon = 1; 
		helpTxt = {tostring(moLanguageXml:getTxt("mohV3nhelp1", nil, nil, nil, true))};
		infoTxt = tostring(moLanguageXml:getTxt("mohV3ninfo", nil, nil, nil, true));
		cmdTable = moGeneralSettings;
		cmdValue = "modOn";
		cmdType = "boolean";
		buttonTxt = "";	
	};	
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "testSetFrozen_";
		isHidden = false; 
		buttonType = 5; 
		buttonWidth = 0; 		
		txtOverButton = "Player Frozen"; 
		helpIcon = 1; 
		helpTxt = {tostring(moLanguageXml:getTxt("setfrozenhelp1", nil, nil, nil, true))};
		infoTxt = tostring(moLanguageXml:getTxt("setfrozeninfo", nil, nil, nil, true));
		cmdTable = moGeneralSettings;
		cmdValue = "setFrozen";
		cmdType = "boolean";
		buttonTxt = "";	
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=1, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();	
	--line 1
end;

