objectstorages = {};

--needs module objectstorages
--lineType 2/objectstorages
function objectstorages:load(objectstorageName)
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};		
	if moObjectStorages.values.storages ~= nil and moObjectStorages.values.storages[objectstorageName] ~= nil then		
		for objectstorage=1, #moObjectStorages.values.storages[objectstorageName] do		
			if moObjectStorages.values.storages[objectstorageName][objectstorage] ~= nil then				
				local objectstorageGeneral = moObjectStorages.values.storages[objectstorageName][objectstorage].general[1];
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];			
				
				if #moObjectStorages.values.storages[objectstorageName] > 1 and objectstorage ~= 1 then					
					isLineTable.setLineBorderNewObject = true;	
				end;
				
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = bgas.returnLineHelpIconClick
				isLineTable.helpTxt = "Click ObjectName for MapHotSpot";
				
				isLineTable.ownValues = {objectstorageName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].nodeId = objectstorageGeneral.object.nodeId;
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
				isLineTable.txt[1].bold = true;				
				local isNearObject = moModule:nearPlayerPosition(objectstorageGeneral.object, 10);				
				if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = objectstorages.returnClickObjectName;end;				
				if isNearObject ~= nil and isNearObject then
					isLineTable.txt[1].txt = ">>".. objectstorageGeneral.objectName.. "<<";
				else
					isLineTable.txt[1].txt = objectstorageGeneral.objectName;
				end;
				isLineTable.txt[1].txtPos = 1;				
				
				--output				
				local objectstorageOutput = moObjectStorages.values.storages[objectstorageName][objectstorage].output;
				if objectstorageOutput ~= nil and #objectstorageOutput > 0 then
					--isLineTable.lineBorder = {4, 0.0005, false, true, false, false, moColors:getColor(moObjectStorages.values.txtTitleColor)};					
					local outputTable = moObjectStorages.values.storages[objectstorageName][objectstorage].output[1];
					---					
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];			
					isLineTable.ownValues = {objectstorageName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};
					isLineTable.txt[1].width = 70;	--width prozent	
					isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = moLanguageXml:getTxt("capacity", nil, "Capacity:");				
					isLineTable.txt[2] = {};
					isLineTable.txt[2].width = 30;	--width prozent	
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = tostring(outputTable.capacity);
					isLineTable.txt[2].txtPos = 2;
					
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];			
					isLineTable.ownValues = {objectstorageName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};
					isLineTable.txt[1].width = 70;	--width prozent	
					isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = outputTable.fillTypeName;					
					isLineTable.txt[2] = {};
					isLineTable.txt[2].width = 30;	--width prozent	
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = outputTable.fillLevel;
					isLineTable.txt[2].txtPos = 2;
				else
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];			
					isLineTable.ownValues = {objectstorageName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};
					isLineTable.txt[1].width = 70;	--width prozent	
					isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[1].bold = moModule.values.txtBold;
					isLineTable.txt[1].txt = moLanguageXml:getTxt("empty", nil, "Empty")					
					isLineTable.txt[2] = {};
					isLineTable.txt[2].width = 30;	--width prozent	
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[2].bold = moModule.values.txtBold;
					isLineTable.txt[2].txt = "-";
					isLineTable.txt[2].txtPos = 2;
				end;			
				--output								
			end;		
		end;		
	end;	
	objectstorages[objectstorageName] = {output=lineTable};	
end;

function objectstorages.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(objectstorages[args.ownValues[1]].output[args.line].helpTxt);
		end;
	end;
end;

function objectstorages.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local objectstorageName = args.ownValues[1];			
			if objectstorages[objectstorageName] ~= nil and objectstorages[objectstorageName].output ~= nil and objectstorages[objectstorageName].output[args.line] ~= nil then
				local nodeId = objectstorages[objectstorageName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;
		end;		
	end;
end;

function objectstorages.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.objectstorages.isRunning = true;moModule.active.objectstorages.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local objectstorageName = args.ownValues[1];		
			objectstorages:load(objectstorageName);
			return objectstorages[objectstorageName].output;
		end;
	end;
end;

function objectstorages.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--objectstorages:load();	
end;

function objectstorages:generateCmd(objectstorageName)
	local _, errorTable = 0, {};
	function insertCmd(objectstorageName, objectsNodes, objectsIds)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local objectstorageNameTemp = tostring(objectstorageName):lower();	
		local languageName = moLanguageXml:getTxt(objectstorageNameTemp, nil, objectstorageName);
		newCmdTable.cmdTable[1] = {
			cmdName = "objectstorages_".. tostring(objectstorageName);
			displayName = moLanguageXml:getTxt("objectstorages", nil, "ObjectStorages").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "ObjectStorages";
			infoTxt = "Zeigt alle ObjectStorages an (".. tostring(languageName).. ")";
			helpTxt = "View all ObjectStorages (".. tostring(objectstorageName).. ")";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = objectstorages.giveOutputTable; --a function
			ownValues = {objectstorageName, objectsNodes, objectsIds}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate objectstorages Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if objectstorageName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "objectstorages_".. objectstorageName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(objectstorageName);end;
	else
		if moObjectStorages.values.storages ~= nil then
			for objectstorageName, _ in pairs (moObjectStorages.values.storages) do
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "objectstorages_".. objectstorageName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(objectstorageName, moModule:getObjectIds(moObjectStorages.values.storages[objectstorageName]));end;
			end;
		end;
	end;	
end;